unit Uhdd;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CPort, ComCtrls, CPortCtl, ShellApi;

type
  TForm1 = class(TForm)
    ComPort1: TComPort;
    Button1: TButton;
    Button2: TButton;
    RichEdit1: TRichEdit;
    ComboBox1: TComboBox;
    Button3: TButton;
    Memo1: TMemo;
    ComLed1: TComLed;
    ComLed2: TComLed;
    Button4: TButton;
    Memo2: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    TrackBar3: TTrackBar;
    Label13: TLabel;
    Label14: TLabel;
    Button5: TButton;
    Button6: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    CheckBox1: TCheckBox;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ComPort1DSRChange(Sender: TObject; OnOff: Boolean);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure ComPort1RxChar(Sender: TObject; Count: Integer);
    procedure RichEdit1Change(Sender: TObject);
    procedure Label16Click(Sender: TObject);
    procedure Label16MouseEnter(Sender: TObject);
    procedure Label16MouseLeave(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
    procedure GetSymbol();
    function isDigit(ch: char): boolean;
    function IsAlpha(c: char): boolean;
    procedure T_();
    procedure S_();
    procedure Prikaz_();
    function Vystup_() : word;
    function Opakuj_() : word;
    function Rotuj_() : word;
    function Reset_() : word;
    function Casovanie_() : word;
    function Ak_() : word;
    function Label_() : string;
    function Retazec_() : string;
    function MalePismeno_() : char;
    function  B_konst_() : boolean;
    function  O_konst_() : byte;
    function  C_konst_() : byte;
    function  R_konst_() : byte;
    function  Cislica_() : char;

    function SetBit(const Value: Word; const Bit: Byte): Word;
    function ClearBit(const Value: Word; const Bit: Byte): Word;
    function GetBit(const Value: Word; const Bit: Byte): Boolean;

    function SetLoByte(const Value: word; const LoByte: byte) : word;
    function SetHiByte(const Value: word; const HiByte: byte) : word;

    function GetLoByte(const Value: word) : byte;
    function GetHiByte(const Value: word) : byte;

    function IsThere(Value : string; nav : array of string) : boolean;
    function IndexOf(Value : string; nav : array of string) : byte;

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const
  sLineFeed = #13#10;
  res_word_RESET = 'RESET';
  res_word_CASOVANIE = 'CASOVANIE';
  res_word_PERIODA = 'PERIODA';
  res_word_OPAKUJ = 'OPAKUJ';
  res_word_VYSTUP = 'VYSTUP';
  res_word_CAS = 'CAS';
  res_word_ROTUJ = 'ROTUJ';
  res_word_STALE = 'STALE';
  res_word_DOLAVA = 'DOLAVA';
  res_word_DOPRAVA = 'DOPRAVA';
  res_word_ROZBEH = 'ROZBEH';
  res_word_AK = 'AK';
  res_word_KOMPARATOR = 'KOMPARATOR';
  res_word_DIGITAL = 'DIGITAL';
  res_word_VSTUP1 = 'VSTUP1';
  res_word_VSTUP2 = 'VSTUP2';
  res_word_NEG_VSTUP1 = 'NEG_VSTUP1';
  res_word_NEG_VSTUP2 = 'NEG_VSTUP2';
  res_word_SKOK = 'SKOK';
  res_word_AND_OP = 'AND';
  res_word_NAND_OP = 'NAND';
  res_word_OR_OP = 'OR';
  res_word_NOR_OP = 'NOR';
  res_word_PROGRAM = 'PROGRAM';
  res_word_KONIEC = 'KONIEC';

type
TLex = (
        NL = 0,
        LZAT = 1,
        PZAT = 2,
        VSTUP1 = 3,
        VSTUP2 = 4,
        VELKE_P = 5,
        MALE_P = 6,
        CK = 7,
        MEDZ = 8,
        OPAKUJ = 9,
        RESET = 10,
        CASOVANIE = 11,
        PERIODA = 12,
        CYKLUS = 13,
        VYSTUP = 14,
        CAS = 15,
        ROTUJ = 16,
        STALE = 17,
        DOLAVA = 18,
        DOPRAVA = 19,
        ROZBEH = 20,
        AK = 21,
        DIGITAL = 22,
        KOMPARATOR = 23,
        NEG_VSTUP1 = 24,
        NEG_VSTUP2 = 25,
        AND_OP = 26,
        NAND_OP = 27,
        OR_OP = 28,
        NOR_OP = 29,
        SKOK = 30,
        DVOJBODKA = 31,
        PROGRAM_ = 32,
        KONIEC = 33,
        OSTATNE = 34,
        CIARKA = 35
        );

var symbol : TLex;    znak, error_char : char;
    error : boolean = false; dlzka_vyrazu, index, err_count, riadok, pozicia, docasny_index : integer;
    eeprom : array[0..127] of byte;
    navestia : array[0..127] of string;
    nezname_navestia : array[0..127] of string;
    uspesny_preklad : boolean = false;
   chyba : boolean = false; e_p : byte;
    ports:TStringList; selText : string;
    zmena_programu : boolean = false;

procedure TForm1.FormShow(Sender: TObject);
begin
  //ComPort1.Open;
  Memo1.Clear;
 // Richedit1.Text := '// tu mete napsa svoj program';
chyba := true;
try
 ports := TStringList.Create;
 EnumComPorts(ports);
 ComboBox1.Items.AddStrings(ports);
 if ComboBox1.Items.Count > 0 then
begin
 ComboBox1.ItemIndex := 0;
 chyba := false;
end;
 except
  MessageBox(0, PChar('Nenaiel som vhodn sriov port na vaom potai!!! Ak ide o laptot, tak sa uistite, e USB prevodnk na COM sriov port je sprvne pripojen k laptopu. ' ), 'Nenaiel sa sriov port!', MB_OK or MB_ICONINFORMATION);
   ComboBox1.Items.Add('n/a');
   ComboBox1.Text := 'n/a';
   chyba := true;
 end;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  //Comport1.Close;
    ports.Free;
  try
  if ComPort1.Connected then ComPort1.Close;
  except
   MessageBox(0, PChar('COM port bol nhle odpojen. Je mon, e ste vytiahli prevodnk z USB na Sriov port skr ako ste ukonili tento program. ' ), 'Chyba!', MB_OK or MB_ICONERROR);
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var i:byte; cakatel : word; dlzka_ep : byte;
begin
 uspesny_preklad := false;
 for i:=0 to 127 do
 begin eeprom[i] := $FF; navestia[i] := ''; nezname_navestia[i] := ''; end;

 //vyplnenie EEPROMy
 eeprom[0] := TrackBar1.Position;
 cakatel := TrackBar2.Position;
 if not ((Lo(cakatel) = 255 ) or (Lo(cakatel) = 254)) then eeprom[1] := Lo(cakatel)
 else eeprom[1] := 253;
 if not ((Hi(cakatel) = 255) or (Hi(cakatel) = 254)) then eeprom[2] := Hi(cakatel)
 else eeprom[2] := 253;
 eeprom[3] := TrackBar3.Position;
 Memo2.Clear;
 Memo2.Font.Color := clRed;
 Memo2.Lines.Add('0: ' + IntToStr(eeprom[0]) + ' ' + IntToStr(eeprom[1]) + ' ' + IntToStr(eeprom[2]) + ' ' + IntToStr(eeprom[3]) + ' ');
 e_p := 4;
    err_count := 0;
    riadok := 1;
    pozicia := 0;
    Memo1.Clear;
    Memo1.Font.Color := clYellow;
    Memo1.Lines.Add('Zanam preklada...');
    Memo1.Lines.Add(TimeToStr(now));
   dlzka_vyrazu := Length(RichEdit1.Text);
  index := 1;
  docasny_index := index;
 //implikant := 1;
 error := false;
 symbol := NL;
 if dlzka_vyrazu > 0 then begin
    GetSymbol();
    S_;
    dlzka_ep := e_p;
    i := 0;
    while(true) do
        BEGIN
           if not (nezname_navestia[i] = '') then
           begin
            if (IsThere(nezname_navestia[i],navestia))
            then
                begin
                  eeprom[i] := IndexOf(nezname_navestia[i],navestia);
                end
                else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : neznme nvestie: ' + nezname_navestia[i]); end;
           end;
          i := i + 1;
          if (i > 127) then break;
        END;
        if not(error) and not(err_count > 0) then
        begin
          Memo2.Clear;
           Memo2.Font.Color := clLime;
           Memo2.Lines.Add('0: ' + IntToStr(eeprom[0]) + ' ' + IntToStr(eeprom[1]) + ' ' + IntToStr(eeprom[2]) + ' ' + IntToStr(eeprom[3]) + ' ');
          e_p := 4;
          while(true) do
          begin
            if not (navestia[e_p] = '') then Memo2.Lines.Add(IntToStr(e_p) + ': ' + navestia[e_p]);
            Memo2.Lines.Add(IntToStr(e_p) + ': ' + IntToStr(eeprom[e_p]) + ' ' + IntToStr(eeprom[e_p+1]));
           // if (eeprom[e_p] = 255) then break;
            e_p := e_p + 2;
            if (e_p > dlzka_ep) then break;
            if (e_p > 127) then break;
          end;
          Memo1.Lines.Add('Preklad prebehol spene!');
          Memo1.Font.Color := clLime;
          Memo1.Lines.Add('Mete odosla program do mikrokontrolra PIC cez seriov COM rozhranie!');
          uspesny_preklad := true;
          zmena_programu := false;
        end;
  end
 else
 begin
 //chybova hlaska na prazdny vyraz
  Memo1.Lines.Add('! chyba: nie je tu iadny program na preloenie');
 end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
{ComPort1.WriteStr(Char(128) + Char(254) + Char($0) + Char($1) + Char($0) + Char($0)
                  + Char($02) + Char($FF)  + Char(255));  }
 if not chyba then
  if not ComPort1.Connected then  begin
ComPort1.Port := ComboBox1.Items[ComboBox1.ItemIndex];
ComPort1.BaudRate := br300;
 if CheckBox1.Checked then
 begin ComPort1.FlowControl.FlowControl := fcCustom;
       ComPort1.FlowControl.ControlDTR := dtrDisable;
       ComPort1.FlowControl.ControlRTS := rtsDisable;
       ComPort1.FlowControl.OutCTSFlow := true;
       ComPort1.FlowControl.OutDSRFlow := false;
 end
 else
 begin
       ComPort1.FlowControl.ControlDTR := dtrDisable;
       ComPort1.FlowControl.ControlRTS := rtsDisable;
       ComPort1.FlowControl.OutCTSFlow := false;
       ComPort1.FlowControl.OutDSRFlow := false;
       ComPort1.FlowControl.FlowControl := fcNone;
 end;

try
ComPort1.Open;
Comport1.SetRTS(true);
ComPort1.SetDTR(false);
    Button3.Enabled := false;
    Button2.Caption := 'Odpoji';
    ComboBox1.Enabled := false;
    CheckBox1.Enabled := false;
    //Button1.Enabled := false;
except
  MessageBox(0, PChar('Nemem sa pripoji cez PORT '+ ComboBox1.Items[ComboBox1.ItemIndex] + '. Tento port je obsaden inm programom alebo to nie je sriov port!!! Skste vybra in port.' ), 'Chyba!', MB_OK or MB_ICONERROR);
  chyba := true;
  seltext := ComboBox1.Items[ComboBox1.ItemIndex];
end;
 end
 else begin
 try
    ComPort1.Close;
 ComboBox1.Enabled := true;
        CheckBox1.Enabled := true;
      except
   MessageBox(0, PChar('COM port bol nhle odpojen. Je mon, e ste vytiahli prevodnk z USB na Sriov port skr ako ste tento program odpojili z portu. ' ), 'Chyba!', MB_OK or MB_ICONERROR);
   ComboBox1.Enabled := true;
       CheckBox1.Enabled := true;
      //Button1.Enabled := true;
       Button4.Enabled := false;
  end;
    Button3.Enabled := true;
        //  Button1.Enabled := true;
        Button2.Caption := 'Pripoji';
            Button4.Enabled := false;
   end;

end;

procedure TForm1.Button3Click(Sender: TObject);
var tt:string; k:integer;
begin
 chyba := true;
 ComboBox1.Items.Clear;
try
 ports := TStringList.Create;
 EnumComPorts(ports);
 ComboBox1.Items.AddStrings(ports);
 if ComboBox1.Items.Count > 0 then
begin
 ComboBox1.ItemIndex := 0;
 chyba := false;
 tt:='';
 for k:=0 to (ports.Count-1) do tt := tt  + ports.Strings[k] + ', ';
 MessageBox(0, PChar(tt), 'Naiel som tieto sriov porty!', MB_OK or MB_ICONINFORMATION);
end;
 except
  MessageBox(0, PChar('Nenaiel som vhodn sriov port na vaom potai!!! Ak ide o laptot, tak sa uistite, e USB prevodnk na COM sriov port je sprvne pripojen k laptopu. ' ), 'Nenaiel sa sriov port!', MB_OK or MB_ICONINFORMATION);
   ComboBox1.Items.Add('n/a');
   ComboBox1.Text := 'n/a';
   chyba := true;
 end;


end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
 if not ( seltext = ComboBox1.Items[ComboBox1.ItemIndex]) then chyba := false;
end;

procedure TForm1.ComPort1DSRChange(Sender: TObject; OnOff: Boolean);
begin
   if OnOff then Button4.Enabled := true
 else Button4.Enabled := false;
end;

procedure TForm1.GetSymbol();
var i :integer; patri : boolean; test_znak : char;
begin
    patri := false;
    pozicia := pozicia + (index - docasny_index);
    docasny_index := index;
    if (index <= dlzka_vyrazu) then begin
		while(true) do begin
		if (index <= dlzka_vyrazu) then	znak := RichEdit1.text[index]
    else break; //getchar();
			case(znak) of
        ' ': begin symbol := MEDZ; index := index + 1; break; end;
        ',': begin symbol := CIARKA; index := index + 1; break end;
        #10: begin symbol := NL; index := index + 1; riadok := riadok + 1; pozicia := 0; end;
        #13: begin symbol := NL; index := index + 1; break; end;
        '(': begin symbol := LZAT; index := index + 1; break; end;
        ')': begin symbol := PZAT; index := index + 1; break; end;
        ':': begin symbol := DVOJBODKA; index := index + 1; break; end;
        '/': begin
                  symbol := NL;
                  while(true) do begin
                  index := index + 1;
                  if (index > length(RichEdit1.text)) then begin error := true; break; end;
                  znak := RichEdit1.text[index];
                  if (znak = #13) then break;
                  end;
                    //index := index + 1;
                    pozicia := 0;
                    //riadok := riadok + 1;
                  end;
        'O': begin
                  //OPAKUJ
                  patri := true;
                  docasny_index := index;
                  for i:=1 to length(res_word_OPAKUJ) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_OPAKUJ[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := OPAKUJ; break; end
                  else index := docasny_index;
                  //OR_OP
                  patri := true;
                  for i:=1 to length(res_word_OR_OP) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_OR_OP[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := OR_OP; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;
        'R': begin
                  //RESET
                  docasny_index := index;
                  patri := true;
                  for i:=1 to length(res_word_RESET) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_RESET[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := RESET; break; end
                  else index := docasny_index;
                  //ROTUJ
                  patri := true;
                  for i:=1 to length(res_word_ROTUJ) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_ROTUJ[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := ROTUJ; break; end
                  else index := docasny_index;
                  //ROZBEH
                  patri := true;
                  for i:=1 to length(res_word_ROZBEH) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_ROZBEH[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := ROZBEH; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;
        'C': begin
                  docasny_index := index;
                  //CASOVANIE
                  patri := true;
                  for i:=1 to length(res_word_CASOVANIE) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_CASOVANIE[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := CASOVANIE; break; end
                  else index := docasny_index;
                  //CAS
                  patri := true;
                  for i:=1 to length(res_word_CAS) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_CAS[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := CAS; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;
        'P': begin
                  //PERIODA
                  docasny_index := index;
                  patri := true;
                  for i:=1 to length(res_word_PERIODA) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_PERIODA[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := PERIODA; break; end
                  else index := docasny_index;
                  //PROGRAM
                  patri := true;
                  for i:=1 to length(res_word_PROGRAM) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_PROGRAM[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := PROGRAM_; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;
        'K': begin
                  docasny_index := index;
                  //KOMPARATOR
                  patri := true;
                  for i:=1 to length(res_word_KOMPARATOR) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_KOMPARATOR[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := KOMPARATOR; break; end
                  else index := docasny_index;
                  //KONIEC
                  patri := true;
                  for i:=1 to length(res_word_KONIEC) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_KONIEC[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := KONIEC; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;
        'S': begin
                  //STALE
                  docasny_index := index;
                  patri := true;
                  for i:=1 to length(res_word_STALE) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_STALE[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := STALE; break; end
                  else index := docasny_index;
                  //SKOK
                  patri := true;
                  for i:=1 to length(res_word_SKOK) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_SKOK[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := SKOK; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;
        'D': begin
                  //DOLAVA
                  docasny_index := index;
                  patri := true;
                  for i:=1 to length(res_word_DOLAVA) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_DOLAVA[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := DOLAVA; break; end
                  else index := docasny_index;
                  //DOPRAVA
                  patri := true;
                  for i:=1 to length(res_word_DOPRAVA) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_DOPRAVA[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := DOPRAVA; break; end
                  else index := docasny_index;
                  //DIGITAL
                  patri := true;
                  for i:=1 to length(res_word_DIGITAL) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_DIGITAL[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := DIGITAL; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;
        'A': begin
                  //AK
                  docasny_index := index;
                  patri := true;
                  for i:=1 to length(res_word_AK) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_AK[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := AK; break; end
                  else index := docasny_index;
                  //AND
                  patri := true;
                  for i:=1 to length(res_word_AND_OP) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_AND_OP[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := AND_OP; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;
        'V': begin
                  //VSTUP1
                  docasny_index := index;
                  patri := true;
                  for i:=1 to length(res_word_VSTUP1) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_VSTUP1[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := VSTUP1; break; end
                  else index := docasny_index;
                  //VSTUP2
                  patri := true;
                  for i:=1 to length(res_word_VSTUP2) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_VSTUP2[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := VSTUP2; break; end
                  else index := docasny_index;
                  //VYSTUP
                  patri := true;
                  for i:=1 to length(res_word_VYSTUP) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_VYSTUP[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := VYSTUP; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;
        'N': begin
                  //NOR_OP
                  docasny_index := index;
                  patri := true;
                  for i:=1 to length(res_word_NOR_OP) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_NOR_OP[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := NOR_OP; break; end
                  else index := docasny_index;
                  //NAND_OP
                  patri := true;
                  for i:=1 to length(res_word_NAND_OP) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_NAND_OP[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := NAND_OP; break; end
                  else index := docasny_index;
                  //NEG_VSTUP2
                  patri := true;
                  for i:=1 to length(res_word_NEG_VSTUP2) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_NEG_VSTUP2[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := NEG_VSTUP2; break; end
                  else index := docasny_index;
                  //NEG_VSTUP1
                  patri := true;
                  for i:=1 to length(res_word_NEG_VSTUP1) do begin
                  znak := RichEdit1.text[index];
                  if (res_word_NEG_VSTUP1[i] = znak) then index := index + 1
                  else begin patri := false; break; end;
                  end;
                  if patri then begin symbol := NEG_VSTUP1; break; end
                  else index := docasny_index;
                  //inak velke pismeno
                  symbol := VELKE_P;
                  znak := RichEdit1.text[index];
                  index := index + 1;
                  break;
              end;

 				//...
				else  begin
					if (isdigit(znak)) then begin //celociselna konstanta
						//...
						 symbol := CK;
             index := index + 1;
						break;
					end else if(isalpha(znak)) then begin //identifikator
                      if znak in ['A'..'Z'] then
                      begin
                        symbol := VELKE_P;
                      end
                      else
                      begin
                        symbol := MALE_P;
                      end;
						//...
						//najskor test na rezervovane slovo
						// {sym=REZERVOVANE;return;}
						//symbol = ID;
                   index := index + 1;
					 	      break;
				        	end else
                  BEGIN
                    //ostatne znaky
                    symbol := OSTATNE;
                    error_char := znak;
                    error := true;
                     index := index + 1;
                    break;
                  END;
            end;
 //koniec switch
 			end;
//koniec while
		end;
//koniec podmienky if not (index > dlzka_vyrazu) then begin
    end
    else begin error := true; {ShowMessage('Koniec vyrazu!!!');} end;
//koniec procedury
end;

function TForm1.isDigit(ch: char): boolean;
begin 
  if ch in ['0'..'9'] then 
    isDigit := true 
  else 
    isDigit := false;
end;

function TForm1.IsAlpha(c: char): boolean;
begin
   IsAlpha := upcase(c) in ['A'..'Z'];
end;

//GRAMATIKA
    procedure TForm1.S_();
    begin
        //odstran zbytocne NOVY RIADOK
        while(symbol = NL) do begin if error then break; GetSymbol(); end;
        //PROGRAM
       if (symbol = PROGRAM_) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz PROGRAM'); end;
       //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
       //LABEL_
       Label_;
       //T_
        T_;
       //KONIEC
       if (symbol = KONIEC) then begin if (error) or (err_count > 0) then Memo1.Lines.Add(' Nedokem preloi zdrojov kd! Opravte chyby a skste znovu! '); end
       else
       begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz KONIEC alebo in platn prkazy'); end;
    end;

    procedure TForm1.T_();
    begin
    //{MEDZERA}
    while(symbol = MEDZ) do begin if error then break; GetSymbol(); end;
    //NOVY RIADOK
       if (symbol = NL) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa nov riadok'); end;
     //{MEDZERA|NOVYRIADOK}
       while(symbol = NL)or(symbol = MEDZ) do begin if error then break; GetSymbol(); end;
   //{PRIKAZ_ {MEDZERA} NOVY RIADOK {NOVY RIADOK}}
     while ((symbol = VYSTUP) or
            (symbol = OPAKUJ) or
            (symbol = ROTUJ) or
            (symbol = RESET) or
            (symbol = CASOVANIE) or
            (symbol = AK) or
            (symbol = MALE_P) or (symbol = VELKE_P) or (symbol = CK))
            do begin
             if error then break;
      //PRIKAZ
           Prikaz_;
      //{MEDZERA}
      while(symbol = MEDZ) do begin if error then break; GetSymbol(); end;
      //NOVY RIADOK
       if (symbol = NL) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa nov riadok'); end;
      //{MEDZERA|NOVYRIADOK}
        while(symbol = MEDZ)or(symbol = NL) do begin if error then break; GetSymbol(); end;
       end;
      //{MEDZERA|NOVYRIADOK}
        while(symbol = MEDZ)or(symbol = NL) do begin if error then break; GetSymbol(); end;
    end;

    procedure TForm1.Prikaz_();
    var hodnota : word; navest : boolean; pom_nav : string;
    begin
      navest := false;
      hodnota := 0;
      case(symbol) of
      VYSTUP:  hodnota := Vystup_;
      OPAKUJ:  hodnota := Opakuj_;
      ROTUJ:   hodnota := Rotuj_;
      RESET:   hodnota := Reset_;
      CASOVANIE:  hodnota := Casovanie_;
      AK:  hodnota := Ak_;
      else
        //Memo1.Lines.Add('! chyba: nerospoznan prkaz');
        if (symbol = MALE_P)or(symbol = VELKE_P)or(symbol = CK) then
          begin
            pom_nav := Label_;
            if not IsThere(pom_nav,navestia) then navestia[e_p] := pom_nav
            else begin
            err_count := err_count + 1;
            Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : nzvy nvest sa nesm opakova, duplicitn nzov nvestia: ' + pom_nav);
            end;
            navest := true;
          end;
      end;
           if not navest then
            begin
              eeprom[e_p] := Lo(hodnota and $00FF);
              eeprom[e_p + 1] := Hi(hodnota and $FF00);
              Memo2.Lines.Add(IntToStr(e_p) + ': ' + IntToStr(eeprom[e_p]) + ' ' + IntToStr(eeprom[e_p+1]) + ' ');
              e_p := e_p + 2;
            end
           else Memo2.Lines.Add(IntToStr(e_p) + ': ' + navestia[e_p]);
    end;

    function TForm1.Vystup_() : word;
    var hodnota : word;
    begin
      hodnota := 0;
    //VYSTUP
       if (symbol = VYSTUP) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz VYSTUP'); end;
    //LAVA ZATVORKA
       if (symbol = LZAT) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa av ztvorka "("'); end;
   //BINARNA KONSTANTA
      if B_konst_ then hodnota := SetBit(hodnota,2)
      else hodnota := ClearBit(hodnota,2);
   //CIARKA
       if (symbol = CIARKA) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa iarka ","'); end;
   //BINARNA KONSTANTA
      if B_konst_ then hodnota := SetBit(hodnota,1)
      else hodnota := ClearBit(hodnota,1);
   //CIARKA
       if (symbol = CIARKA) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa iarka ","'); end;
   //BINARNA KONSTANTA
      if B_konst_ then hodnota := SetBit(hodnota,0)
      else hodnota := ClearBit(hodnota,0);
    //PRAVA ZATVORKA
       if (symbol = PZAT) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa prav ztvorka ")"'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //KROK
       if (symbol = CAS) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz CAS'); end;
    //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
    //CELOCISELNA KONSTANTA
      hodnota := SetHiByte(hodnota,C_konst_); //rozsah od 0 do 255

    result := hodnota;
    end;

    function TForm1.Opakuj_() : word;
    var hodnota : word; pomocna, pom_poz : byte; pom_nav : string;
    begin
        hodnota := 0;
        pom_poz := 4;
   //OPAKUJ
       if (symbol = OPAKUJ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz OPAKUJ'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //LABEL
        pom_nav := Label_;
       if (IsThere(pom_nav,navestia)) then pom_poz := IndexOf(pom_nav,navestia)
       else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : neznme nvestie: ' + pom_nav + ' Nvestie mus by pred cyklom!'); end;
       hodnota := SetLoByte(hodnota,pom_poz);
       hodnota := SetBit(hodnota,7);
    //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
    //CELOCISELNA KONSTANTA
      hodnota := SetHiByte(hodnota,C_konst_); //rozsah od 0 do 255
      result := hodnota;
    end;

    function TForm1.Rotuj_() : word;
    var hodnota : word; pomocna1, pomocna2 : byte;
    begin
      hodnota := 0;
    //ROTUJ
       if (symbol = ROTUJ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz ROTUJ'); end;
    //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
    //STALE
       if (symbol = STALE) then
      begin
       hodnota := SetBit(hodnota,4);
       GetSymbol();
    //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
      end else hodnota := ClearBit(hodnota,4);
    //(DOLAVA | DOPRAVA)
      case(symbol) of
      DOLAVA: begin hodnota := ClearBit(hodnota,5); hodnota := SetBit(hodnota,6); GetSymbol(); end;
      DOPRAVA: begin hodnota := ClearBit(hodnota,6); hodnota := SetBit(hodnota,5); GetSymbol(); end;
      else
        error := true; err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz DOLAVA alebo prkaz DOPRAVA');
      end;
   //CIARKA
       if (symbol = CIARKA) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa iarka ","'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //ROZBEH
       if (symbol = ROZBEH) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz ROZBEH'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //R CELOCISELNA KONSTANTA
        pomocna1 := Lo(hodnota);
        pomocna1 := pomocna1 and $F0;
        pomocna2 := R_konst_();
        pomocna2 := pomocna2 and $0F;
       hodnota := SetLoByte(hodnota,(pomocna1 or pomocna2));
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //CAS
       if (symbol = CAS) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz CAS'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //CELOCISELNA KONSTANTA
       hodnota := SetHiByte(hodnota,C_konst_);
       result := hodnota;
    end;

    function TForm1.Reset_() : word;
    begin
   //RESET
       if (symbol = RESET) then begin   GetSymbol(); end
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz RESET'); end;
    result := $FFFF;
    end;

    function TForm1.Casovanie_() : word;
    var hodnota : word;
    begin
   //CASOVANIE
       if (symbol = CASOVANIE) then begin   GetSymbol(); end
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz CASOVANIE'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
  //O CELOCISELNA KONSTANTA
      hodnota := SetLoByte(hodnota,O_konst_);
      hodnota := SetBit(hodnota,3);
   //CIARKA
       if (symbol = CIARKA) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa iarka ","'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //PERIODA
       if (symbol = PERIODA) then begin   GetSymbol(); end
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz PERIODA'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //CELOCISELNA KONSTANTA
       hodnota := SetHiByte(hodnota,C_konst_); //roozsah od 0 do 255
       result := hodnota;
    end;

    function TForm1.Ak_() : word;
    var hodnota : word; pom_nav : string; pom_vstup : boolean; pom_poz : byte;
    begin
      hodnota := 0;
   //AK
       if (symbol = AK) then begin   GetSymbol(); end
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz AK'); end;
      hodnota := SetBit(hodnota,4);
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
  //(DIGITAL | KOMPARATOR)
        case(symbol) of
          DIGITAL: begin  hodnota := ClearBit(hodnota,3); GetSymbol(); end;
          KOMPARATOR: begin  hodnota := SetBit(hodnota,3); GetSymbol(); end;
          else
            error := true;
            err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz DIGITAL alebo KOMPARATOR');
          end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
     //LAVA ZATVORKA
       if (symbol = LZAT) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa av ztvorka "("'); end;
   //(VSTUP1 | NEG_VSTUP1)
       case(symbol) of
        VSTUP1: begin  hodnota := ClearBit(hodnota,2); GetSymbol(); pom_vstup:=false; end;
        NEG_VSTUP1: begin hodnota := SetBit(hodnota,2); GetSymbol(); pom_vstup:=true; end;
        else
         err_count := err_count + 1;
         Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz VSTUP1 alebo NEG_VSTUP1');
        end;
    //PRAVA ZATVORKA
       if (symbol = PZAT) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa prav ztvorka ")"'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
  //(AND | NAND | OR | NOR)
      case(symbol) of
      AND_OP: begin hodnota := ClearBit(hodnota,1); hodnota := ClearBit(hodnota,0);  GetSymbol(); end;
      NAND_OP: begin hodnota := ClearBit(hodnota,1); hodnota := SetBit(hodnota,0);  GetSymbol(); end;
      OR_OP: begin hodnota := SetBit(hodnota,1); hodnota := ClearBit(hodnota,0);  GetSymbol(); end;
      NOR_OP: begin hodnota := SetBit(hodnota,1); hodnota := SetBit(hodnota,0);  GetSymbol(); end;
      else
         err_count := err_count + 1;
         Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz AND alebo NAND alebo OR alebo NOR');
      end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //LAVA ZATVORKA
       if (symbol = LZAT) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa av ztvorka "("'); end;
   //(VSTUP2 | NEG_VSTUP2)
       case(symbol) of
        VSTUP2: begin if pom_vstup then begin error := true; err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : negcia iba jednho vstupu! Sprvne (VSTUP1) opercia (VSTUP2) alebo (NEG_VSTUP1) opercia (NEG_VSTUP2)'); end;  GetSymbol(); end;
        NEG_VSTUP2: begin if not pom_vstup then begin error := true; err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : negcia iba jednho vstupu! Sprvne (VSTUP1) opercia (VSTUP2) alebo (NEG_VSTUP1) opercia (NEG_VSTUP2)'); end;  GetSymbol(); end;
        else
         err_count := err_count + 1;
         Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz VSTUP2 alebo NEG_VSTUP2');
        end;
    //PRAVA ZATVORKA
       if (symbol = PZAT) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa prav ztvorka ")"'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //SKOK
       if (symbol = SKOK) then begin   GetSymbol(); end
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa prkaz SKOK'); end;
   //MEDZERA
       if (symbol = MEDZ) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa medzera'); end;
   //LABEL
       pom_nav := Label_;
       if (IsThere(pom_nav,navestia)) then pom_poz := IndexOf(pom_nav,navestia)
       else begin
        //err_count := err_count + 1;
        //Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : neznme nvestie: ' + pom_nav + ' Nvestie mus by pred cyklom!');
        nezname_navestia[e_p+1] := pom_nav;
     //defaultna adresa skoku
        pom_poz := 4;
       end;
       hodnota := SetHiByte(hodnota,pom_poz);
       result := hodnota;
    end;

    function TForm1.Label_() : string;
    var hodnota : string;
    begin
     //retazec
      hodnota := Retazec_;
      //dvojbodka
       if (symbol = DVOJBODKA) then GetSymbol()
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakval sa symbol dvojbodka ":"'); end;
      result := hodnota;
    end;

    function TForm1.Retazec_() : string;
    var hodnota : string;
    begin
      //male pismeno
      hodnota := MalePismeno_;
      //{male_pismeno|cislica|medzera|velke_pismeno}
      while (symbol = MALE_P)or(symbol = CK)or(symbol = VELKE_P)or(symbol = MEDZ) do
      begin
      if error then break;
          //{MEDZERA}
          while(symbol = MEDZ) do begin if error then break; hodnota := hodnota + ' '; GetSymbol(); end;
          hodnota := hodnota + MalePismeno_;
         end;{ P [ X ] }
      result := hodnota;
    end;

    function TForm1.MalePismeno_() : char;
    var hodnota : char;
    begin
        hodnota := ' ';
       if (symbol = MALE_P)or(symbol = CK)or(symbol = VELKE_P) then begin hodnota := znak; GetSymbol(); end
        else begin err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvalo sa vek, mal psmeno alebo slica'); end;
       result := hodnota;
    end;

    function TForm1.B_konst_() : boolean;
    var hodnota:boolean;
     begin
      hodnota := false;
      if(symbol = CK) then begin
        case(znak) of
        '0': begin GetSymbol(); hodnota := false; end;
        '1': begin GetSymbol(); hodnota := true; end;
        else
          error := true;
          Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa binrna hodnota 1 alebo 0');
        end;
      end else begin error := true; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa binrna kontanta'); end;
      result := hodnota;
    end;

    function TForm1.C_konst_() : byte;
    var hodnota : byte; test : byte;
    begin
      test := 0;
      hodnota := 0;
     //CISLICA
      hodnota := StrToInt(Cislica_);
      //{CISLICA}
      while(symbol = CK) do
      begin
        if error then break;
        test := StrToInt(Cislica_);
        if ((((hodnota = 25) and (test <= 3)) or (hodnota < 25)) and not error) then
        hodnota := (hodnota * 10) + test
        else
        begin
          error := true;
          err_count := err_count + 1;
          Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa celoselna kontanta v rozsahu od 0 do 253');
          break;
        end;
      end;
      result := hodnota;
    end;


  function TForm1.R_konst_() : byte;
  var hodnota, test : byte;
  begin
      test := 0;
      hodnota := 0;
     //CISLICA
      hodnota := StrToInt(Cislica_);
      //{CISLICA}
      while(symbol = CK) do
      begin
        if error then break;
        test := StrToInt(Cislica_);
        if ((((hodnota = 1) and (test <= 5)) or (hodnota < 1)) and not error) then
        hodnota := (hodnota * 10) + test
        else
        begin
          error := true;
          err_count := err_count + 1;
          Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa celoselna kontanta v rozsahu od 0 do 15');
          break;
        end;
      end;
      result := hodnota;
  end;

    function  TForm1.O_konst_() : byte;
    var hodnota, test : byte;
    begin
      hodnota := 0;
      if(symbol = CK) then begin
         if not error then test := StrToInt(Cislica_);
        if not (test > 7) then hodnota := test
        else begin
          error := true;
          Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa celoseln kontanta v rozsahu od 0 do 7');
        end;
      end else begin error := true; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa celoseln kontanta v rozsahu od 0 do 7'); end;
      result := hodnota;
    end;

    function TForm1.Cislica_() : char;
    var hodnota : char;
    begin
        hodnota := '0';
       if (symbol = CK) then begin hodnota := znak; GetSymbol(); end
       else begin error := true; err_count := err_count + 1; Memo1.Lines.Add(IntToStr(riadok) + '. riadok, pozcia:' + IntToStr(pozicia) + '  ! Chyba . ' + IntToStr(err_count) + ' : oakvala sa celoselna kontanta'); end;
      result := hodnota;
    end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
 Label7.Caption := IntToStr(TrackBar1.Position);
  if (uspesny_preklad) then zmena_programu := true;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
 Label10.Caption := IntToStr(TrackBar2.Position);
  if (uspesny_preklad) then zmena_programu := true;
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
  Label14.Caption := IntToStr(TrackBar3.Position);
   if (uspesny_preklad) then zmena_programu := true;
end;

function TForm1.SetBit(const Value: word; const Bit: Byte): word;
begin
	Result := Value or (1 shl Bit);
end;

function TForm1.ClearBit(const Value: word; const Bit: Byte): word;
begin
	Result := Value and not (1 shl Bit);
end;

function TForm1.SetLoByte(const Value: word; const LoByte: byte) : word;
var pomocna1, pomocna2 : word;
begin
  pomocna1 := LoByte;
  pomocna2 := Value;
  pomocna1 := pomocna1 and $00FF;
  pomocna2 := pomocna2 and $FF00;
  Result := pomocna1 or pomocna2;
end;

function TForm1.SetHiByte(const Value: word; const HiByte: byte) : word;
var pomocna1, pomocna2 : word;
begin
  pomocna1 := HiByte;
  pomocna1 := pomocna1 shl 8;
  pomocna2 := Value;
  pomocna1 := pomocna1 and $FF00;
  pomocna2 := pomocna2 and $00FF;
  Result := pomocna1 or pomocna2;
end;

function TForm1.GetLoByte(const Value: word) : byte;
begin
  Result := Lo(Value);
end;

function TForm1.GetHiByte(const Value: word) : byte;
begin
  Result := Hi(Value);
end;

function TForm1.GetBit(const Value: word; const Bit: Byte): Boolean;
begin
  Result := (Value and (1 shl Bit)) <> 0;
end;


function TForm1.IsThere(Value : string; nav : array of string) : boolean;
var i:byte; hodnota : boolean;
begin
  hodnota := false;
  for i:=0 to 127 do
  begin
    if (Value = nav[i]) then begin hodnota := true; break; end;
  end;
  result := hodnota;
end;

function TForm1.IndexOf(Value : string; nav : array of string) : byte;
var i:byte; hodnota : byte;
begin
  hodnota := 4;
  for i:=0 to 127 do
  begin
    if (Value = nav[i]) then begin hodnota := i; break; end;
  end;
  result := hodnota;
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
 if (OpenDialog1.Execute)
 then RichEdit1.Lines.LoadFromFile(OpenDialog1.FileName);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
 if (SaveDialog1.Execute) then RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.Button4Click(Sender: TObject);
var buff : array[0..129] of byte; odoslat,k,m: integer;  povol : boolean;
begin
    k := 0;
    if zmena_programu then begin
    m := MessageBox(0, PChar('Chcete nahra posledn preloen binrny vstup?'), 'Program bol zmenen a nepreloen', MB_YESNO or MB_ICONINFORMATION);
     if (m = 6)   //6 true
     then povol := true
     else povol := false;
     end
     else povol := true;

 if povol then
  if (uspesny_preklad) then begin
   // ComPort1.WriteStr(Char(128)+ Char(254)); //+Char(1)+Char(50)+Char(255)+Char(255));
      Memo1.Lines.Add(' Odosielam dta...');
     buff[0] := 128;
     buff[1] := 254;
     for k:=2 to 129 do
     begin
     buff[k] := eeprom[k-2];
     if eeprom[k-2] = 255 then begin odoslat := k+1; break; end;
     end;
     ComPort1.Write(buff,odoslat);
   { while(true) do
    begin
      ComPort1.WriteStr(Char(eeprom[k]));
      if (eeprom[k] = 255) then break;
      k := k+1;
      if (k>128) then break;
    end;    }
    //ComPort1.WriteStr(Char(255));
  end else
  MessageBox(0, PChar('Najprv treba preloi program a potom sa me odosla!'), 'Nemem odosla program', MB_OK or MB_ICONINFORMATION);


end;



procedure TForm1.ComPort1RxChar(Sender: TObject; Count: Integer);
var s:string; i:integer;
begin
  ComPort1.ReadStr(s,128);
  for i:=1 to Length(s) do
  begin
  Memo1.Lines.Add('Odosielam : ' + IntToStr(Ord(s[i])));
  if Ord(s[i]) = 255 then Memo1.Lines.Add('Koniec odosielania!');
  end;
  end;

procedure TForm1.RichEdit1Change(Sender: TObject);
begin
 if (uspesny_preklad) then zmena_programu := true;
end;

procedure TForm1.Label16Click(Sender: TObject);
var em_subject, em_body, em_mail : string;
begin
  //Label19.Font.Color := clRed;
 em_subject := 'Riadenie krokovho motoreka';
  em_body := 'Mm takto otzku:';

  em_mail := 'mailto:fubu@pobox.sk?subject=' +
    em_subject + '&body=' + em_body ;

  ShellExecute(Handle,'open',PChar(em_mail), nil, nil, SW_SHOWNORMAL) ;

end;

procedure TForm1.Label16MouseEnter(Sender: TObject);
begin
 Label16.Font.Color := clLime;
end;

procedure TForm1.Label16MouseLeave(Sender: TObject);
begin
 Label16.Font.Color := clNavy;
end;

end.
